;;	Copyright © CrackTime Studios - 2020
;;
;;	This file is part of Poisoned Escape
;;
;;    Poisoned Escape is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Poisoned Escape is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Poisoned Escape.  If not, see <https://www.gnu.org/licenses/>.

.include "entity_templates.h.s"
.include "assets/assets.h.s"
.include "animations.h.s"
.include "../sys/render.h.s"
.include "entity.h.s"
.include "../sys/collisions.h.s"
.include "../sys/ai_control.h.s"

;;======================================================================================
;; PUBLIC VARIABLES
;;======================================================================================

player_tmpl_cmps = e_cmps_movable|e_cmps_renderable|e_cmps_collisionable|e_cmps_tile_collisionable|e_cmps_anime|e_cmps_gravitable
enemy_tmpl_cmps = e_cmps_movable|e_cmps_renderable|e_cmps_collisionable|e_cmps_ai|e_cmps_anime

player_tmpl::
   DefineType        e_type_player, player_tmpl_cmps
   DefinePhysics     38, 92, 0, 0, spr_player_w, spr_player_h
   DefineAi          e_ai_st_move_to, nullptr
   DefineAnim        8, nullptr, 0, _player_stop_right, 0
   DefineCollisions  e_type_end|e_type_easter_egg_end
enemy_tmpl::
   DefineType        e_type_enemy, enemy_tmpl_cmps
   DefinePhysics     38, 92, 0, 0, spr_spider_w, spr_spider_h
   DefineAi          e_ai_st_move_to, sys_ai_control_move_on_y_axis
   DefineAnim        5, nullptr, 1, nullptr, 0
   DefineCollisions  e_type_player
end_tmpl::
   DefineType        e_type_end, e_cmps_collisionable
   DefinePhysics     (screen_width-spr_end_w), (screen_height-3*8), 0, 0, spr_end_w, spr_end_h
   DefineAi          e_ai_st_noAI, nullptr
   DefineAnim        0, #_sp_end, 0, nullptr, 0
   DefineCollisions  e_type_invalid

babosa_tmpl::
   DefineType        e_type_enemy, enemy_tmpl_cmps
   DefinePhysics     38, 92, 0, 0, spr_babosa_w, spr_babosa_h
   DefineAi          e_ai_st_move_to, sys_ai_control_move_on_x_axis
   DefineAnim        5, nullptr, 1, nullptr, 0
   DefineCollisions  e_type_player      
   
ghost_tmpl::
   DefineType        e_type_enemy, enemy_tmpl_cmps
   DefinePhysics     38, 92, 0, 0, spr_ghost_w, spr_ghost_h
   DefineAi          e_ai_st_move_to, sys_ai_control_ghost_wave
   DefineAnim        5, nullptr, 2, nullptr, 0
   DefineCollisions  e_type_player

bat_tmpl::
   DefineType        e_type_enemy, enemy_tmpl_cmps
   DefinePhysics     38, 92, 0, 0, spr_bat_w, spr_bat_h
   DefineAi          e_ai_st_move_to, sys_ai_control_bat_wave
   DefineAnim        5, nullptr, 3, nullptr, 0
   DefineCollisions  e_type_player

;;======================================================================================
;; PRIVATE VARIABLES
;;======================================================================================



;;======================================================================================
;; PUBLIC ROUTINES
;;======================================================================================



;;======================================================================================
;; PRIVATE ROUTINES
;;======================================================================================
