;;	Copyright © CrackTime Studios - 2020
;;
;;	This file is part of Poisoned Escape
;;
;;    Poisoned Escape is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Poisoned Escape is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Poisoned Escape.  If not, see <https://www.gnu.org/licenses/>.

.module GAME_MANAGER

;;================================================
;; CONSTANTS
;;================================================
margin_on_floor = 0
game_stopped = 0
game_playing = 1
game_next    = 2


.macro CreateEntity _name, _x, _y
   ld    hl, #_name'_tmpl
   call  man_game_create_template_entity     ;; Creamos el jugador  
.endm

.macro CreateEntityXY _name, _x, _y
   ld    hl, #_name'_tmpl
   call  man_game_create_template_entity     ;; Creamos el jugador  

   ld    e_x(ix), #_x        
   ld    e_y(ix), #_y
.endm

.macro ChangeAILimits _axisP, _init, _end
   ld    e_ai_aim_init_'_axisP(ix), #_init
   ld    e_ai_aim_end_'_axisP(ix),  #_end

   ;ld    hl, #sys_ai_control_move_on_'_axisP'_axis
   ;ld    e_ai_movPtr_l(ix), l
   ;ld    e_ai_movPtr_h(ix), h
.endm

;;.macro flipEnd 
;;   ld    de, #_sp_end_1
;;   ld    e_sprPtr_h(ix), d
;;   ld    e_sprPtr_l(ix), e
;;.endm

;;================================================
;; PUBLIC VARIABLES
;;================================================

.globl playerOnFloor
.globl gameState


;;================================================
;; PRIVATE VARIABLES
;;================================================



;;================================================
;; PUBLIC ROUTINES
;;================================================

.globl man_game_init
.globl man_game_play
.globl man_game_create_template_entity
.globl man_game_player_jump
.globl man_game_end_level
.globl man_game_next_level
.globl man_game_getTilesetPtrHL
.globl man_game_getTilemapPtrDE
.globl man_game_floor_collision
.globl man_game_player_on_air
.globl man_game_easter_egg_level

.globl man_game_pause

;;================================================
;; PRIVATE ROUTINES
;;================================================