;;	Copyright © CrackTime Studios - 2020
;;
;;	This file is part of Poisoned Escape
;;
;;    Poisoned Escape is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Poisoned Escape is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Poisoned Escape.  If not, see <https://www.gnu.org/licenses/>.

.include "input.h.s"
.include "../sys/physics.h.s"
.include "cpct_functions.h.s"
.include "cpctelera.h.s"
.include "../man/entity.h.s"
.include "../man/game.h.s"
.include "../man/menu.h.s"
.include "../sys/render.h.s" ;; Posteriormente se anyadiran animaciones
.include "../man/entity_templates.h.s"
.include "../man/musics.h.s"


;CreateControl  ctrl_move_right,  #Key_D
;CreateControl  ctrl_move_left,   #Key_A
;CreateControl  ctrl_jump,        #Key_Space     


;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Actualiza el sistema de input mediante las entradas de teclado del usuario
;; ENTRADAS
;;  -
;; SALIDAS
;;  -
;; MODIFICA
;;  HL, C
;; PRECONDICIONES
;;  -  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_input_update::
    ld    hl,   #sys_input_update_one_entity
    ld    c,    #e_cmps_movable|#e_cmps_input               ;; Todas las que tipo movibles
   
    call  man_entity_for_all_matching
  
    ret

sys_input_update_menu::
   ;;call cpct_scanKeyboard_f_asm

   ld    hl, #Key_1                        ;; Espacio pulsado
   call cpct_isKeyPressed_asm
   call nz, man_menu_load_game
   
   ld    hl, #Key_2                        ;; Espacio pulsado
   call cpct_isKeyPressed_asm
   call  nz, man_menu_load_instructions
   ;
   ld    hl, #Key_3                        ;; Espacio pulsado
   call cpct_isKeyPressed_asm
   call  nz, man_menu_load_credits
                      
ret

sys_input_update_menu_credits_and_instructions::
   ;;call cpct_scanKeyboard_f_asm
   call cpct_isAnyKeyPressed_f_asm         ;; Si se pusa cualquier tecla
   call nz, man_menu_load_main_menu

ret

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; Recoge las entradas al input de una entidad en concreto
;; ENTRADAS
;;  - IX (entidad)
;; SALIDAS
;;  -
;; MODIFICA
;;  
;; PRECONDICIONES
;;  -  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
sys_input_update_one_entity::
   ld    e_vx(ix), #0
   ld    e_vxf(ix), #0
   
   call cpct_scanKeyboard_f_asm

   ld    hl, #Key_M                          ;; Tecla M pulsada
   call cpct_isKeyPressed_asm
   call  nz, #man_music_mute_music

   ld    hl, #Key_P                          ;; Tecla M pulsada
   call cpct_isKeyPressed_asm
   call  nz, #man_game_pause


   ld    hl, #Key_Space                        ;; Espacio pulsado
   call cpct_isKeyPressed_asm
   call  nz, #man_game_player_jump
     
   ld    hl, #Key_D
   call cpct_isKeyPressed_asm
   jr     z, #D_NotPressed
   D_Pressed:                                 ;; Tecla D pulsada
      ld    de, #velocity_on_x
      ld    h, e_vx(ix)
      ld    l, e_vxf(ix)
      add   hl, de
      ld    e_vx(ix), h
      ld    e_vxf(ix), l

   ret
   D_NotPressed:                              ;; D no pulsada
      ld    hl, #Key_A
      call cpct_isKeyPressed_asm
      jr     z, #A_NotPresed
   A_Pressed:                                 ;; A pulsada
      ld   de, #-velocity_on_x
      ld    h, e_vx(ix)
      ld    l, e_vxf(ix)
      add  hl, de
      ld    e_vx(ix), h
      ld    e_vxf(ix), l
   ret
   A_NotPresed:
      call sys_physics_round_XY
      ld    a, e_x_rounded(ix)
      ld    e_x(ix), a
      ld    e_xf(ix), #0                      ;; cuando se para redondeamos                 
ret

sys_input_wait_releaseKey::
   on_pause:
      call cpct_scanKeyboard_f_asm
      call cpct_isAnyKeyPressed_f_asm         ;; Si se pusa cualquier tecla
      jr nz, #on_pause
ret

sys_input_update_pause::
   ld    hl, #Key_M                          ;; Tecla M pulsada
   call cpct_isKeyPressed_asm
   call  nz, #man_music_mute_music

   call cpct_scanKeyboard_f_asm
   ld    hl, #Key_P                          ;; Tecla P pulsada
   call cpct_isKeyPressed_asm
ret
