;;	Copyright © CrackTime Studios - 2020
;;
;;	This file is part of Poisoned Escape
;;
;;    Poisoned Escape is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Poisoned Escape is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Poisoned Escape.  If not, see <https://www.gnu.org/licenses/>.

.include "music.h.s"
.include "cpctelera.h.s"
.include "cpct_functions.h.s"
.include "../assets/assets.h.s"
.include "../man/musics.h.s"


music_counter: .db 06      ;; 6 -> 0 50 hz

int_handler_music_input_50:
   push af
   push bc
   push de
   push hl

   ld a, (music_counter)
   dec a
   jr nz, _cont_50     
_zero_50:   
   call  cpct_akp_musicPlay_asm   ;; 1 de cada 6 NO -> 12 (25 hz) interrupciones a music play
   call cpct_scanKeyboard_if_asm

   ld a, #6
_cont_50:
   ld (music_counter), a

   pop hl
   pop de
   pop bc
   pop af

   ei          ;; habilitar interrupciones
   reti

int_handler_music_input_25:
   push af
   push bc
   push de
   push hl

   ld a, (music_counter)
   dec a
   jr nz, _cont_25      
_zero_25:
_guard:
   scf      
   call c, cpct_akp_musicPlay_asm   ;; 1 de cada 6 NO -> 12 (25 hz) interrupciones a music play
   call cpct_scanKeyboard_if_asm

   ld a, (_guard)                   ;; cambio bit mas alto, deja carry a 0, ejecuta musica a 25 hz
   xor #0x80
   ld (_guard), a

   ld a, #6
_cont_25:
   ld (music_counter), a

   pop hl
   pop de
   pop bc
   pop af

   ei          ;; habilitar interrupciones
   reti

int_handler_input:
   push af
   push bc
   push de
   push hl

   call cpct_scanKeyboard_if_asm

   pop hl
   pop de
   pop bc
   pop af

   ei          ;; habilitar interrupciones
   reti

sys_music_enable_music_25::           ;; Pone la primera interrupción
   call wait_vsync  ;; Principio senyal VSync

   ld a, #6
   ld (music_counter), a

   ld hl, #0x38
   ld (hl), #0xC3
   inc hl
   ld (hl), #<int_handler_music_input_25
   inc hl
   ld (hl), #>int_handler_music_input_25
   inc hl
   ld (hl), #0xC9
   ret

sys_music_enable_music_50::           ;; Pone la primera interrupción
   call wait_vsync  ;; Principio senyal VSync

   ld a, #6
   ld (music_counter), a

   ld hl, #0x38
   ld (hl), #0xC3
   inc hl
   ld (hl), #<int_handler_music_input_50
   inc hl
   ld (hl), #>int_handler_music_input_50
   inc hl
   ld (hl), #0xC9
   ret

sys_music_stop_music::
   call wait_vsync
   
   ld hl, #0x38
   ld (hl), #0xC3
   inc hl
   ld (hl), #<int_handler_input
   inc hl
   ld (hl), #>int_handler_input
   inc hl
   ld (hl), #0xC9
   ret
   ret

wait_vsync:
   call cpct_waitVSYNC_asm
   halt
   halt
   call cpct_waitVSYNC_asm    ;; Principio senyal VSync
   ret