;;	Copyright © CrackTime Studios - 2020
;;
;;	This file is part of Poisoned Escape
;;
;;    Poisoned Escape is free software: you can redistribute it and/or modify
;;    it under the terms of the GNU General Public License as published by
;;    the Free Software Foundation, either version 3 of the License, or
;;    (at your option) any later version.
;;
;;    Poisoned Escape is distributed in the hope that it will be useful,
;;    but WITHOUT ANY WARRANTY; without even the implied warranty of
;;    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;    GNU General Public License for more details.
;;
;;    You should have received a copy of the GNU General Public License
;;    along with Poisoned Escape.  If not, see <https://www.gnu.org/licenses/>.

.module PHYSICS_SYSTEM

;;================================================
;; CONSTANTS
;;================================================

velocity_on_x        = 0x0090
max_vy               = 7
gravity_acceleration = 0x0080
jump_velocity        = -7  


;; Crea un control en memoria (variable que contiene tecla)
.macro CreateControl _key_name, _key;, _routine
   _key_name::
      .dw _key
      ;.dw _routine ;; En un futiro se puede usar para poder recorrer con un bucle
.endm

;; Comprueba el control que está en memoria y podría cambiarse en el juego
.macro IfControlPressedJump _key, _etiqueta
   ld    hl, (_key)              ;; Tecla
   call  cpct_isKeyPressed_asm   ;; Deja en L=A el estado. 0 no pulsado, 1 pulsado
   jr    nz, _etiqueta           ;; Salta a la etiqueta si está la tecla _key pulsada
.endm


;;================================================
;; PUBLIC VARIABLES
;;================================================



;;================================================
;; PRIVATE VARIABLES
;;================================================



;;================================================
;; PUBLIC ROUTINES
;;================================================

.globl sys_physics_init
.globl sys_physics_update
.globl sys_physics_update_one_entity
.globl sys_physics_collision_behaviour
.globl sys_physics_round_XY

;;================================================
;; PRIVATE ROUTINES
;;================================================
